#property copyright "FX AI Investments Inc."
#property link      "http://www.fxproadvisor.com"

#property indicator_chart_window

extern double SupRes_Criteria = 0.38;
extern int Min_Hours_to_show = 1;
bool gi_88 = FALSE;
extern bool Draw_Fibo = FALSE;
string gs_96 = "_signs_";
string gs_104;
datetime gt_112;
double gda_116[][6];
double gd_120;
double gd_128;

int init() {
   clear();
   return (0);
}

int deinit() {
   clear();
   return (0);
}

void clear() {
   string ls_0;
   int li_8 = ObjectsTotal();
   for (int li_12 = li_8 - 1; li_12 >= 0; li_12--) {
      ls_0 = ObjectName(li_12);
      if (StringFind(ls_0, gs_96) == 0) ObjectDelete(ls_0);
   }
}

void DrawLine(double ad_0, string as_8, color ai_16, int ai_20, int ai_24) {
   string ls_28 = gs_96 + as_8 + "_" + ai_20;
   if (ObjectFind(ls_28) == -1) {
      ObjectCreate(ls_28, OBJ_HLINE, 0, Time[0], ad_0);
      ObjectSet(ls_28, OBJPROP_COLOR, ai_16);
      ObjectSet(ls_28, OBJPROP_WIDTH, ai_20);
      ObjectSet(ls_28, OBJPROP_STYLE, ai_24);
   }
}

void Draw_Points() {
   double ld_0;
   int li_12;
   int li_16;
   int li_20;
   int li_24;
   int li_28;
   int li_32;
   string ls_36;
   string ls_44;
   int li_8 = ArrayRange(gda_116, 0);
   gd_120 = 0.0;
   gd_128 = 0.0;
   gs_104 = "";
   for (int li_52 = 0; li_52 < li_8; li_52++) {
      li_16 = gda_116[li_52][0];
      li_28 = gda_116[li_52][3];
      li_24 = iBarShift(Symbol(), li_28, li_16);
      if (li_24 * li_28 / 60 >= Min_Hours_to_show) {
         li_12 = iBarShift(Symbol(), li_28, li_16);
         if (gda_116[li_52][1] == 1.0) ld_0 = iHigh(Symbol(), li_28, li_12);
         if (gda_116[li_52][1] == -1.0) ld_0 = iLow(Symbol(), li_28, li_12);
         if (gda_116[li_52][2] < 1.0) li_20 = 7;
         if (gda_116[li_52][2] < 0.95) li_20 = 6;
         if (gda_116[li_52][2] < 0.91) li_20 = 5;
         if (gda_116[li_52][2] < 0.854) li_20 = 4;
         if (gda_116[li_52][2] < 0.764) li_20 = 3;
         if (gda_116[li_52][2] < 0.618) li_20 = 2;
         if (gda_116[li_52][2] < 0.5) li_20 = 1;
         if (gda_116[li_52][2] < 0.38) li_20 = 0;
         if (li_24 * li_28 > 60 * Min_Hours_to_show + 40320) {
            li_32 = Thistle;
            ls_44 = "Month+";
         }
         if (li_24 * li_28 < 60 * Min_Hours_to_show + 40320) {
            li_32 = LightBlue;
            ls_44 = "Month";
         }
         if (li_24 * li_28 < 60 * Min_Hours_to_show + 10080) {
            li_32 = Gainsboro;
            ls_44 = "Week";
         }
         if (li_24 * li_28 < 60 * Min_Hours_to_show + 1440) {
            li_32 = Silver;
            ls_44 = "Day";
         }
         if (li_24 * li_28 < 60 * Min_Hours_to_show + 240) {
            li_32 = Wheat;
            ls_44 = "4 hours";
         }
         if (li_24 * li_28 < 60 * Min_Hours_to_show + 60) {
            li_32 = PaleGreen;
            ls_44 = "Hour";
         }
         if (gi_88) {
            DrawTrend(ld_0, li_16, ld_0, Time[0], DoubleToStr(gda_116[li_52][2], 2) + "_" + li_52 + "_period_" + li_28, li_32, li_20, STYLE_SOLID);
            if (Draw_Fibo) {
               DrawTrend(gda_116[li_52][4], li_16, gda_116[li_52][4], Time[0], DoubleToStr(gda_116[li_52][2], 2) + "_" + li_52 + "_period_fibo_38.2_" + li_28, li_32, 1, STYLE_SOLID);
               DrawTrend(gda_116[li_52][5], li_16, gda_116[li_52][5], Time[0], DoubleToStr(gda_116[li_52][2], 2) + "_" + li_52 + "_period_fibo_61.8_" + li_28, li_32, 1, STYLE_SOLID);
            }
         } else {
            DrawLine(ld_0, DoubleToStr(gda_116[li_52][2], 2) + "_" + li_52, li_32, li_20, STYLE_SOLID);
            if (Draw_Fibo) {
               DrawLine(gda_116[li_52][4], DoubleToStr(gda_116[li_52][2], 2) + "_fibo_38.2_" + li_52, li_32, 1, STYLE_SOLID);
               DrawLine(gda_116[li_52][5], DoubleToStr(gda_116[li_52][2], 2) + "_fibo_61.8_" + li_52, li_32, 1, STYLE_SOLID);
            }
         }
         if (Close[0] > ld_0) {
            gd_120 += Close[0] - ld_0;
            ls_36 = "up";
            continue;
         }
         gd_128 += ld_0 - Close[0];
         ls_36 = "down";
      }
   }
}

void DrawTrend(double ad_0, int ai_8, double ad_12, int ai_20, string as_24, color ai_32, int ai_36, int ai_40) {
   string ls_44 = gs_96 + "_trend_" + as_24;
   if (ObjectFind(ls_44) == -1) {
      ObjectCreate(ls_44, OBJ_TREND, 0, ai_8, ad_0, ai_20, ad_12);
      ObjectSet(ls_44, OBJPROP_COLOR, ai_32);
      ObjectSet(ls_44, OBJPROP_WIDTH, ai_36);
      ObjectSet(ls_44, OBJPROP_STYLE, ai_40);
      ObjectSet(ls_44, OBJPROP_RAY, TRUE);
   }
}

int Get_Next_Period(int ai_0) {
   int li_4;
   switch (ai_0) {
   case 1:
      li_4 = 5;
      break;
   case 5:
      li_4 = 15;
      break;
   case 15:
      li_4 = 30;
      break;
   case 30:
      li_4 = 60;
      break;
   case 60:
      li_4 = 240;
      break;
   case 240:
      li_4 = 1440;
      break;
   case 1440:
      li_4 = 10080;
      break;
   case 10080:
      li_4 = 43200;
      break;
   default:
      li_4 = -1;
   }
   return (li_4);
}

void Search() {
   int li_0;
   int li_12;
   int li_24;
   double ld_28;
   double ld_36;
   double ld_44;
   double ld_52;
   double ld_60;
   bool li_68;
   bool li_72;
   int li_4 = 0;
   int li_8 = Period();
   int li_16 = 3;
   int li_20 = 0;
   while (li_8 != -1) {
      for (int li_76 = li_16; li_76 < 500; li_76++) {
         ld_28 = iHigh(Symbol(), li_8, li_76);
         ld_36 = iLow(Symbol(), li_8, li_76);
         li_68 = FALSE;
         li_72 = FALSE;
         for (int li_80 = 1; li_80 < 500; li_80++) {
            if (li_68 && li_72) break;
            li_0 = li_76 + li_80;
            if (li_0 <= iBars(Symbol(), li_8)) {
               if (!li_68 && iHigh(Symbol(), li_8, li_0) > ld_28) {
                  li_68 = TRUE;
                  ld_44 = 1.0 * li_76 / li_80;
                  if (ld_44 > 1.0) ld_44 = 1 / ld_44;
                  if (ld_44 > SupRes_Criteria) {
                     ArrayResize(gda_116, li_4 + 1);
                     if (Draw_Fibo) {
                        li_24 = iLowest(Symbol(), li_8, MODE_LOW, li_76);
                        ld_52 = iLow(Symbol(), li_8, li_24);
                        ld_60 = ld_28 - ld_52;
                        gda_116[li_4][4] = ld_52 + ld_60 / 2.0;
                        gda_116[li_4][5] = ld_52 + 0.618 * ld_60;
                     }
                     gda_116[li_4][0] = iTime(Symbol(), li_8, li_76);
                     gda_116[li_4][1] = 1;
                     gda_116[li_4][2] = ld_44;
                     gda_116[li_4][3] = li_8;
                     li_4++;
                  }
               }
               if (!li_72 && iLow(Symbol(), li_8, li_0) < ld_36) {
                  li_72 = TRUE;
                  ld_44 = 1.0 * li_76 / li_80;
                  if (ld_44 > 1.0) ld_44 = 1 / ld_44;
                  if (ld_44 > SupRes_Criteria) {
                     ArrayResize(gda_116, li_4 + 1);
                     if (Draw_Fibo) {
                        li_24 = iHighest(Symbol(), li_8, MODE_HIGH, li_76);
                        ld_52 = iHigh(Symbol(), li_8, li_24);
                        ld_60 = ld_52 - ld_36;
                        gda_116[li_4][4] = ld_36 + ld_60 / 2.0;
                        gda_116[li_4][5] = ld_36 + 0.618 * ld_60;
                     }
                     gda_116[li_4][0] = iTime(Symbol(), li_8, li_76);
                     gda_116[li_4][1] = -1;
                     gda_116[li_4][2] = ld_44;
                     gda_116[li_4][3] = li_8;
                     li_4++;
                  }
               }
               li_0 = li_76 - li_80;
               if (li_0 >= 0) {
                  if (!li_68 && iHigh(Symbol(), li_8, li_0) > ld_28) {
                     ld_44 = 1.0 * (li_76 - li_80) / li_80;
                     if (ld_44 < 0.5) continue;
                     li_68 = TRUE;
                     if (ld_44 > 1.0) ld_44 = 1 / ld_44;
                     if (ld_44 > SupRes_Criteria) {
                        ArrayResize(gda_116, li_4 + 1);
                        if (Draw_Fibo) {
                           li_24 = iLowest(Symbol(), li_8, MODE_LOW, li_76);
                           ld_52 = iLow(Symbol(), li_8, li_24);
                           ld_60 = ld_28 - ld_52;
                           gda_116[li_4][4] = ld_52 + ld_60 / 2.0;
                           gda_116[li_4][5] = ld_52 + 0.618 * ld_60;
                        }
                        gda_116[li_4][0] = iTime(Symbol(), li_8, li_76);
                        gda_116[li_4][1] = 1;
                        gda_116[li_4][2] = ld_44;
                        gda_116[li_4][3] = li_8;
                        li_4++;
                     }
                  }
                  if (!li_72 && iLow(Symbol(), li_8, li_0) < ld_36) {
                     ld_44 = 1.0 * (li_76 - li_80) / li_80;
                     if (ld_44 >= 0.5) {
                        li_72 = TRUE;
                        if (ld_44 > 1.0) ld_44 = 1 / ld_44;
                        if (ld_44 > SupRes_Criteria) {
                           ArrayResize(gda_116, li_4 + 1);
                           if (Draw_Fibo) {
                              li_24 = iHighest(Symbol(), li_8, MODE_HIGH, li_76);
                              ld_52 = iHigh(Symbol(), li_8, li_24);
                              ld_60 = ld_52 - ld_36;
                              gda_116[li_4][4] = ld_36 + ld_60 / 2.0;
                              gda_116[li_4][5] = ld_36 + 0.618 * ld_60;
                           }
                           gda_116[li_4][0] = iTime(Symbol(), li_8, li_76);
                           gda_116[li_4][1] = -1;
                           gda_116[li_4][2] = ld_44;
                           gda_116[li_4][3] = li_8;
                           li_4++;
                        }
                     }
                  }
               }
            }
         }
      }
      li_12 = gda_116[li_4 - 1][0];
      li_8 = Get_Next_Period(li_8);
      li_16 = iBarShift(Symbol(), li_8, li_12);
      li_20++;
      if (li_20 > 50) break;
   }
}

int start() {
   double ld_0;
   if (gt_112 < Time[0]) {
      clear();
      Search();
      Draw_Points();
      gt_112 = Time[0];
      if (gd_128 != 0.0) ld_0 = MathAbs(gd_120) / MathAbs(gd_128);
      else ld_0 = 999999.0;
      if (ld_0 < 1.0 && ld_0 != 0.0) ld_0 = -(1 / ld_0);
   }
   return (0);
}